Bug 507554 - Changes for MD boot support for isw array
Changes for MD boot support for isw array
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: mkinitrd (Show other bugs)
12
All Linux
low Severity medium
: ---
: ---
Assigned To: Peter Jones
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-23 06:08 EDT by Jacek Danecki
Modified: 2010-01-12 10:32 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-01-12 10:32:23 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jacek Danecki 2009-06-23 06:08:18 EDT
Current implementation of mkinitd assembles MD array with specific name.
mdadm -As --auto=yes --run /dev/md126
But this is not supported for isw/imsm arrays. As workaround we propose to assemble all devices included in configuration file /etc/mdadm.conf using 
mdadm -Asc /etc/mdadm.conf

Support for isw arrays need running application called mdmon to handle metadata events. This daemon needs to be started before the rootfs being mounted.
After the rootfs is mounted to /sysroot, mdmon is restarted in the new
namespace.  The command "mdmon /proc/mdstat /sysroot" tells mdmon to
terminate any instances in the current namespace and then launch new
instances, chroot to /sysroot, per container device found in /proc/mdstat.

For example part of initrd:

mod scsi_wait_scan
mkblkdevs
mdadm -Asc /etc/mdadm.conf

echo Creating root device.
mkrootdev -t ext3 -o defaults,ro /dev/md126
echo Mounting root filesystem.
mount /sysroot
cond -ne 0 plymouth --hide-splash
echo Setting up other filesystems.
setuproot
loadpolicy
plymouth --newroot=/sysroot
mdmon /proc/mdstat /sysroot
echo Switching to new root and running init.
switchroot
Comment 1 Warren Togami 2009-06-23 10:17:59 EDT
NOTE: mkinitrd is being replaced by dracut for F-12, which does use mdmon prior to mounting and switch_root.  Please verify that it works as expected.  If not we need to know.

http://sourceforge.net/apps/trac/dracut/
Comment 2 Jacek Danecki 2009-06-25 09:56:07 EDT
When will be dracut integrated in rawhide? Can I replace package mkinitrd by the dracut? Is dracut compatible with mkinitrd? My proposal is only temporary fix for mkinitrd to make possible testing whole installation process on MD array.
Comment 3 Jacek Danecki 2009-07-14 07:06:59 EDT
I've created raid 1 in OROM, during installation I've passed iswmd parameter to kernel, so anaconda installed system on md-raid1. I've installed dracut 0.4 and created image for initrd. I've updated menu.lst in grub. After reboot system activated raid using mdadm, but only with one disk.
Comment 4 Hans de Goede 2009-07-16 05:27:41 EDT
(In reply to comment #3)
> I've created raid 1 in OROM, during installation I've passed iswmd parameter to
> kernel, so anaconda installed system on md-raid1. I've installed dracut 0.4 and
> created image for initrd. I've updated menu.lst in grub. After reboot system
> activated raid using mdadm, but only with one disk.  

Hi,

A number of patches from me to fix this have been merged in dracut git, so this
problem should no longer happen in dracut git. See here for the location of
dracut git:
https://fedoraproject.org/wiki/Dracut

Note I'm leaving for vacation for a week tomorrow, so I'll be incommunicado for
a week.
Comment 5 Jacek Danecki 2009-07-23 06:27:06 EDT
I've pulled git version (0.6) with the latest commit:
commit 0e77eb378272ff6117b6857e6f5816460f74471f
Author: Harald Hoyer <harald@redhat.com>
Date:   Thu Jul 23 11:58:24 2009 +0200

    dmraid/mdraid: only try to delete partition 1-1024
    
    add "--nr 1-1024" to partx, otherwise partx will try to delete
    partitions 1-INT_MAX, which takes a long time.

This version worked correctly. System started from raid 1.
Comment 6 Bug Zapper 2009-11-16 05:19:05 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Hans de Goede 2010-01-12 10:32:23 EST
This is a mass edit of all mkinitrd bugs.

Thanks for taking the time to file this bug report (and/or commenting on it).

As you may have heard in Fedora 12 mkinitrd has been replaced by dracut. In Fedora 12 the mkinitrd package is still around as some programs depend on
certain libraries it provides, but mkinitrd itself is no longer used.

In Fedora 13 mkinitrd will be removed completely. This means that all work
on initrd has stopped.

Rather then keeping mkinitrd bugs open and giving false hope they might get fixed we are mass closing them, so as to clearly communicate that no more work will be done on mkinitrd. We apologize for any inconvenience this may cause. 

If you are using Fedora 11 and are experiencing a mkinitrd bug you cannot work around, please upgrade to Fedora 12. If you experience problems with the initrd in Fedora 12, please file a bug against dracut.

Note You need to log in before you can comment on or make changes to this bug.